public class Brackets {

	// ok: e.g. "([([][])()])"
	// wrong: e.g "([)]"
	public static void main(String[] args) {
		CharStack stack = new CharStack();
		String input = IO.readString("Brackets: ");
		char[] inputs = input.toCharArray();
		boolean error = false;
		for (int i = 0; i < inputs.length && !error; i++) {
			char ch = inputs[i];
			switch (ch) {
			case '(':
			case '[':
				stack.push(ch);
				break;
			case ')':
				if (stack.isEmpty() || stack.pop() != '(') {
					error = true;
				}
				break;
			case ']':
				if (stack.isEmpty() || stack.pop() != '[') {
					error = true;
				}
				break;
			}
		}
		if (stack.isEmpty() && !error) {
			System.out.println("brackets are ok");
		} else {
			System.out.println("brackets are wrong");
		}

	}

}
