
class StackElement {
	int value;
	StackElement next;

	StackElement(int v, StackElement n) {
		value = v;
		next = n;
	}
}

class LinkedStack {

	StackElement top;

	LinkedStack() {
		top = null;
	}

	boolean isEmpty() {
		return top == null;
	}

	void push(int value) {
		top = new StackElement(value, top);
	}

	int pop() {
		if (!this.isEmpty()) {
			int result = top.value;
			top = top.next;
			return result;
		}
		return 0; // Fehler! Wird spaeter via Exceptions gehandhabt
	}

	// Testprogramm
	public static void main(String[] args) {
		LinkedStack stack = new LinkedStack();
		for (int i = 0; i < 10; i++) {
			stack.push(i);
		}
		while (!stack.isEmpty()) {
			System.out.println(stack.pop());
		}
	}
}
