
class Queue {

	int[] store;
	int next;

	Queue() { // unbegrent grosse Queue
		this.store = new int[8];
		this.next = 0;
	}

	boolean isEmpty() { // ist leer?
		return this.next == 0;
	}

	void enqueue(int value) { // speichert einen Wert in die Queue
		ensureCapacity();
		this.store[this.next] = value;
		next++;
	}

	int dequeue() { // liefert das aelteste Element der Queue
		if (!this.isEmpty()) {
			int result = store[0];
			for (int i = 0; i < next - 1; i++) {
				store[i] = store[i + 1];
			}
			next--;
			return result;
		}
		return 0; // Fehler! Wird spaeter via Exceptions gehandhabt
	}

	void ensureCapacity() {
		if (next == store.length) {
			int[] buffer = new int[store.length * 2];
			for (int i = 0; i < store.length; i++) {
				buffer[i] = store[i];
			}
			store = buffer;
		}
	}

	// Testprogramm
	public static void main(String[] args) {
		Queue queue = new Queue();
		for (int i = 0; i < 10; i++) {
			queue.enqueue(i);
		}
		while (!queue.isEmpty()) {
			System.out.println(queue.dequeue());
		}
	}
}

