
class Stack {

	int[] store;
	int next;

	Stack() {
		this.store = new int[8];
		this.next = 0;
	}

	boolean isEmpty() {
		return this.next == 0;
	}

	void push(int value) {
		ensureCapacity();
		this.store[this.next] = value;
		next++;
	}

	int pop() {
		if (!this.isEmpty()) {
			next--;
			return this.store[this.next];
		}
		return 0; // Fehler! Wird spaeter via Exceptions gehandhabt
	}

	void ensureCapacity() {
		if (next == store.length) {
			int[] buffer = new int[store.length * 2];
			for (int i = 0; i < store.length; i++) {
				buffer[i] = store[i];
			}
			store = buffer;
		}
	}
}
